/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "xunfeinlpengine.h"

XunfeiNlpEngine::XunfeiNlpEngine() : d(new XunfeiNlpEnginePrivate()) {}

XunfeiNlpEngine::~XunfeiNlpEngine() { delete d; }

std::string XunfeiNlpEngine::engineName() { return d->engineName(); }

void XunfeiNlpEngine::setConfig(const std::string &config) {
    d->setConfig(config);
}

void XunfeiNlpEngine::setChatResultCallback(
    ai_engine::lm::nlp::ChatResultCallback callback) {
    d->setChatResultCallback(callback);
}

void XunfeiNlpEngine::setContextSize(int size) { d->setContextSize(size); }

void XunfeiNlpEngine::clearContext() { d->clearContext(); }

bool XunfeiNlpEngine::initChatModule(ai_engine::lm::EngineError &error) {
    return d->initChatModule(error);
}

bool XunfeiNlpEngine::chat(const std::string &message,
                          ai_engine::lm::EngineError &error) {
    return d->chat(message, error);
}

void XunfeiNlpEngine::stopChat() { d->stopChat(); }

bool XunfeiNlpEngine::destroyChatModule(ai_engine::lm::EngineError &error) {
    return d->destroyChatModule(error);
}
