/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef XUNFEINLPENGINE_H
#define XUNFEINLPENGINE_H

#include <kylin-ai/ai-engine/large-model/cloudnlpengine.h>
#include <kylin-ai/plugins/ai-engines/large-model/xunfeinlpengine_p.h>

class XunfeiNlpEnginePrivate;

class XunfeiNlpEngine : public ai_engine::lm::nlp::AbstractCloudNlpEngine {
public:
    XunfeiNlpEngine();
    ~XunfeiNlpEngine();
    std::string engineName() override;

    void setConfig(const std::string &config) override;

    void setChatResultCallback(ai_engine::lm::nlp::ChatResultCallback callback) override;

    void setContextSize(int size) override;
    void clearContext() override;

    bool initChatModule(ai_engine::lm::EngineError &error) override;
    bool chat(const std::string &message, ai_engine::lm::EngineError &error) override;
    void stopChat() override;
    bool destroyChatModule(ai_engine::lm::EngineError &error) override;

private:
    XunfeiNlpEnginePrivate *d;
};

#endif // XUNFEINLPENGINE_H
