/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "xunfeivisionengine.h"

XunfeiVisionEngine::XunfeiVisionEngine() : d(new XunfeiVisionEnginePrivate()) {}

XunfeiVisionEngine::~XunfeiVisionEngine() { delete d; }
std::string XunfeiVisionEngine::engineName() { return d->engineName(); }

void XunfeiVisionEngine::setConfig(const std::string &config) {
    d->setConfig(config);
}

void XunfeiVisionEngine::setPrompt2ImageCallback(
    ai_engine::lm::vision::ImageResultCallback callback) {
    d->setPrompt2ImageCallback(callback);
}

void XunfeiVisionEngine::setPrompt2ImageSize(int width, int height) {
    d->setPrompt2ImageSize(width, height);
}

void XunfeiVisionEngine::setPrompt2ImageNumber(int number) {
    d->setPrompt2ImageNumber(number);
}

void XunfeiVisionEngine::setPrompt2ImageStyle(int style) {
    d->setPrompt2ImageStyle(style);
}

bool XunfeiVisionEngine::prompt2Image(const std::string &prompt,
                                      ai_engine::lm::EngineError &error) {
    return d->prompt2Image(prompt, error);
}

std::string XunfeiVisionEngine::getPrompt2ImageSupportedParams() const {
    return d->getPrompt2ImageSupportedParams();
}