/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef XUNFEIVISIONENGINE_H
#define XUNFEIVISIONENGINE_H

#include <kylin-ai/ai-engine/large-model/cloudvisionengine.h>
#include <kylin-ai/plugins/ai-engines/large-model/xunfeivisionengine_p.h>

class XunfeiVisionEngine : public ai_engine::lm::vision::AbstractCloudVisionEngine {
public:
    XunfeiVisionEngine();
    ~XunfeiVisionEngine();
    std::string engineName() override;

    void setConfig(const std::string &config) override;

    void setPrompt2ImageCallback(ai_engine::lm::vision::ImageResultCallback callback) override;
    void setPrompt2ImageSize(int width, int height) override;
    void setPrompt2ImageNumber(int number) override;
    void setPrompt2ImageStyle(int style) override;
    std::string getPrompt2ImageSupportedParams() const override;

    bool prompt2Image(const std::string &prompt, ai_engine::lm::EngineError &error) override;

private:
    XunfeiVisionEnginePrivate *d;
};

#endif // XUNFEIVISIONENGINE_H
